package defaultPackage;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.concurrent.atomic.AtomicLong;

import javax.xml.namespace.QName;

import org.apache.abdera.Abdera;
import org.apache.abdera.model.Entry;
import org.apache.abdera.model.ExtensibleElement;
import org.apache.abdera.protocol.Response.ResponseType;
import org.apache.abdera.protocol.client.AbderaClient;
import org.apache.abdera.protocol.client.ClientResponse;
import org.apache.commons.codec.binary.Base64;
import org.apache.commons.httpclient.UsernamePasswordCredentials;

public class ConcurrentUpdateTest {

    public static final String NODE_1 = "http://127.0.0.1:8080/jboss-brms/rest/packages/";
    public static final String NODE_2 = "http://127.0.0.2:8080/jboss-brms/rest/packages/";

    public static AtomicLong counter = new AtomicLong(System.currentTimeMillis());

    public static final void main(String[] args) throws Exception {

        for (int i = 0; i < 1; i++) {

            ExecutorService executor = Executors.newFixedThreadPool(2);

            executor.execute(new Runnable() {

                public void run() {
                    restUpdate(NODE_1, "package1", "test-1", "admin1");
//                    restUpdate(NODE_1, "defaultPackage", "test-1", "admin1");
                }
            });
            executor.execute(new Runnable() {

                public void run() {
                    restUpdate(NODE_2, "package2", "test-2", "admin2");
//                    restUpdate(NODE_1, "defaultPackage", "test-2", "admin");
                }
            });

            executor.shutdown();
            executor.awaitTermination(300, TimeUnit.SECONDS);

        }

    }

    private static void restUpdate(String baseUrl, String packageName, String assetName, String user) {

        try {
            URL url;
            url = new URL(baseUrl + packageName + "/assets/" + assetName + "/binary");
            System.out.println(Thread.currentThread().getName() + " : PUT " + url);

            HttpURLConnection conn = (HttpURLConnection) url.openConnection();
            conn.setDoOutput(true);
            conn.setInstanceFollowRedirects(false);
            conn.setRequestMethod("PUT");
            String auth = user + ":" + user; // password is the same as username
            conn.setRequestProperty("Authorization", "Basic " + Base64.encodeBase64String(auth.getBytes()));
            conn.setRequestProperty("Content-Type", "application/octet-stream");
            conn.setRequestProperty("Accept", "application/atom+xml");
            conn.setRequestProperty("Slug", assetName);
            conn.setDoOutput(true);
            conn.getOutputStream().write(getBytesFromFile(new File("test.xls")));

            conn.connect();
            System.out.println(Thread.currentThread().getName() + " : ResponseCode = " + conn.getResponseCode());

            conn.disconnect();

        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    public static byte[] getBytesFromFile(File file) throws IOException {
        InputStream is = null;
        is = new FileInputStream(file);
        long length = file.length();

        if (length > Integer.MAX_VALUE) {
            return null; // File is too large
        }

        byte[] bytes = new byte[(int) length];

        int offset = 0;
        int numRead = 0;
        while (offset < bytes.length && (numRead = is.read(bytes, offset, bytes.length - offset)) >= 0) {
            offset += numRead;
        }

        if (offset < bytes.length) {
            throw new IOException("Could not completely read file " + file.getName());
        }
        is.close();
        return bytes;
    }

}