package defaultPackage;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.concurrent.atomic.AtomicLong;

import javax.xml.namespace.QName;

import org.apache.abdera.Abdera;
import org.apache.abdera.model.Entry;
import org.apache.abdera.model.ExtensibleElement;
import org.apache.abdera.protocol.Response.ResponseType;
import org.apache.abdera.protocol.client.AbderaClient;
import org.apache.abdera.protocol.client.ClientResponse;
import org.apache.commons.codec.binary.Base64;
import org.apache.commons.httpclient.UsernamePasswordCredentials;

public class InitialAdd {

    public static final String NODE_1 = "http://127.0.0.1:8080/jboss-brms/rest/packages/";

    public static AtomicLong counter = new AtomicLong(System.currentTimeMillis());

    public static final void main(String[] args) throws Exception {

//        restAdd(NODE_1, "defaultPackage", "test-1");
//        restAdd(NODE_1, "defaultPackage", "test-2");
//        restAdd(NODE_1, "defaultPackage", "test-3");
//        restAdd(NODE_1, "defaultPackage", "test-4");
//        restAdd(NODE_1, "defaultPackage", "test-5");
        
        restAdd(NODE_1, "package1", "test-1");
        restAdd(NODE_1, "package2", "test-2");

    }

    private static void restAdd(String baseUrl, String packageName, String assetName) {

        try {
            URL url;
            url = new URL(baseUrl + packageName + "/assets");
            System.out.println(Thread.currentThread().getName() + " : POST " + url);

            HttpURLConnection conn = (HttpURLConnection) url.openConnection();
            conn.setDoOutput(true);
            conn.setInstanceFollowRedirects(false);
            conn.setRequestMethod("POST");
            String auth = "admin:admin";
            conn.setRequestProperty("Authorization", "Basic " + Base64.encodeBase64String(auth.getBytes()));
            conn.setRequestProperty("Content-Type", "application/octet-stream");
            conn.setRequestProperty("Accept", "application/atom+xml");
            conn.setRequestProperty("Slug", assetName);
            conn.setDoOutput(true);
            conn.getOutputStream().write(getBytesFromFile(new File("test.xls")));

            conn.connect();
            System.out.println(Thread.currentThread().getName() + " : ResponseCode = " + conn.getResponseCode());
            
            conn.disconnect();

        } catch (Exception e) {
            e.printStackTrace();
        }

        try {
            Abdera abdera = new Abdera();
            AbderaClient abderaClient = new AbderaClient(abdera);
            abderaClient.usePreemptiveAuthentication(true);
            abderaClient.addCredentials(baseUrl, null, null, new UsernamePasswordCredentials("admin", "admin"));

            Entry entry = abdera.newEntry();
            entry.setSummary("This is the test XLS");

            ExtensibleElement metadataElement = entry.addExtension(new QName("", "metadata"));
            ExtensibleElement formatElement = metadataElement.addExtension(new QName("", "format"));
            formatElement.addSimpleExtension(new QName("", "value"), "xls");

            String restUrl = baseUrl + packageName + "/assets/" + URLEncoder.encode(assetName, "UTF-8");

            System.out.println(Thread.currentThread().getName() + " : PUT " + restUrl);

            ClientResponse resp = abderaClient.put(restUrl, entry);

            if (resp.getType() == ResponseType.SUCCESS) {
                System.out.println(Thread.currentThread().getName() + " : success");
            } else {
                System.out.println(Thread.currentThread().getName() + " : failure " + resp.getType());
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static byte[] getBytesFromFile(File file) throws IOException {
        InputStream is = null;
        is = new FileInputStream(file);
        long length = file.length();

        if (length > Integer.MAX_VALUE) {
            return null; // File is too large
        }

        byte[] bytes = new byte[(int) length];

        int offset = 0;
        int numRead = 0;
        while (offset < bytes.length && (numRead = is.read(bytes, offset, bytes.length - offset)) >= 0) {
            offset += numRead;
        }

        if (offset < bytes.length) {
            throw new IOException("Could not completely read file " + file.getName());
        }
        is.close();
        return bytes;
    }

}